diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/msg.c
--- a/src/dep/msg.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/dep/msg.c	Sun Oct 27 22:49:29 2013 -0700
@@ -1,4 +1,5 @@
 /*-
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
  * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
  *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
  * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
@@ -39,10 +40,6 @@
 
 #include "../ptpd.h"
 
-#ifdef PTP_EXPERIMENTAL
-extern RunTimeOpts rtOpts; 
-#endif
-
 /*Unpack Header from IN buffer to msgTmpHeader field */
 void 
 msgUnpackHeader(Octet * buf, MsgHeader * header)
@@ -73,23 +70,34 @@
 
 /*Pack header message into OUT buffer of ptpClock*/
 void 
-msgPackHeader(Octet * buf, PtpClock * ptpClock)
+msgPackHeader(Octet * buf, PtpClock * ptpClock, unsigned int messageType)
 {
-	Nibble transport = 0x80;
+	const UInteger8 transportSpecific = 0x00;
+  UInteger8 octet0 = transportSpecific | (UInteger8)messageType;
+  
+	/* (spec annex D) */
+	*(UInteger8 *) (buf + 0) = octet0;
+	*(UInteger4 *) (buf + 1) = ptpClock->versionNumber;
+	*(UInteger8 *) (buf + 2) = 0; /* messageLength */
+	*(UInteger8 *) (buf + 3) = 0; /* messageLength */
+	*(UInteger8 *) (buf + 4) = ptpClock->domainNumber;
+	*(UInteger8 *) (buf + 5) = 0;
 
-	/* (spec annex D) */
-	*(UInteger8 *) (buf + 0) = transport;
-	*(UInteger4 *) (buf + 1) = ptpClock->versionNumber;
-	*(UInteger8 *) (buf + 4) = ptpClock->domainNumber;
+	if (((messageType == SYNC) || (messageType == PDELAY_RESP)) &&
+		(ptpClock->twoStepFlag)) {
+		*(UInteger8 *) (buf + 6) = PTP_TWO_STEP;
+	} else {
+		*(UInteger8 *) (buf + 6) = 0;
+	}
+	*(UInteger8 *) (buf + 7) = 0;
 
-	/* TODO: this bit should have been active only for sync and PdelayResp */
-	if (ptpClock->twoStepFlag)
-		*(UInteger8 *) (buf + 6) = PTP_TWO_STEP;
-
-	memset((buf + 8), 0, 8);
+	memset((buf + 8), 0, 12);
 	memcpy((buf + 20), ptpClock->portIdentity.clockIdentity, 
 	       CLOCK_IDENTITY_LENGTH);
 	*(UInteger16 *) (buf + 28) = flip16(ptpClock->portIdentity.portNumber);
+	*(UInteger8 *) (buf + 30) = 0; /* sequenceId */
+	*(UInteger8 *) (buf + 31) = 0; /* sequenceId */
+	*(UInteger8 *) (buf + 32) = 0; /* controlField */
 	*(UInteger8 *) (buf + 33) = 0x7F;
 	/* Default value(spec Table 24) */
 }
@@ -100,13 +108,9 @@
 void 
 msgPackSync(Octet * buf, Timestamp * originTimestamp, PtpClock * ptpClock)
 {
-	msgPackHeader(buf, ptpClock);
+	msgPackHeader(buf, ptpClock, SYNC);
 	
 	/* changes in header */
-	*(char *)(buf + 0) = *(char *)(buf + 0) & 0xF0;
-	/* RAZ messageType */
-	*(char *)(buf + 0) = *(char *)(buf + 0) | 0x00;
-	/* Table 19 */
 	*(UInteger16 *) (buf + 2) = flip16(SYNC_LENGTH);
 	*(UInteger16 *) (buf + 30) = flip16(ptpClock->sentSyncSequenceId);
 	*(UInteger8 *) (buf + 32) = 0x00;
@@ -142,15 +146,26 @@
 void 
 msgPackAnnounce(Octet * buf, PtpClock * ptpClock)
 {
-	msgPackHeader(buf, ptpClock);
+	UInteger16 tmp;
 
+	msgPackHeader(buf, ptpClock, ANNOUNCE);
+
+	if (ptpClock->leap59) {
+		*(UInteger8 *) (buf + 7) |= 0x02;
+	}
+	if (ptpClock->leap61) {
+		*(UInteger8 *) (buf + 7) |= 0x01;
+	}
+	
+	if (ptpClock->currentUtcOffsetValid)
+		*(UInteger8 *) (buf + 7) |= 0x04;
 	
 	/* changes in header */
-	*(char *)(buf + 0) = *(char *)(buf + 0) & 0xF0;
-	/* RAZ messageType */
-	*(char *)(buf + 0) = *(char *)(buf + 0) | 0x0B;
 	/* Table 19 */
-	*(UInteger16 *) (buf + 2) = flip16(ANNOUNCE_LENGTH);
+	/* *(UInteger16 *) (buf + 2) = flip16(ANNOUNCE_LENGTH);
+	 */
+	tmp = flip16(ANNOUNCE_LENGTH);
+	memcpy((buf + 2), &tmp, sizeof(UInteger16));
 	*(UInteger16 *) (buf + 30) = flip16(ptpClock->sentAnnounceSequenceId);
 	*(UInteger8 *) (buf + 32) = 0x05;
 	/* Table 23 */
@@ -166,7 +181,10 @@
 		flip16(ptpClock->clockQuality.offsetScaledLogVariance);
 	*(UInteger8 *) (buf + 52) = ptpClock->grandmasterPriority2;
 	memcpy((buf + 53), ptpClock->grandmasterIdentity, CLOCK_IDENTITY_LENGTH);
-	*(UInteger16 *) (buf + 61) = flip16(ptpClock->stepsRemoved);
+/*	*(UInteger16 *) (buf + 61) = flip16(ptpClock->stepsRemoved);
+ */
+	tmp = flip16(ptpClock->stepsRemoved);
+	memcpy((buf+61), &tmp, sizeof(UInteger16));
 	*(Enumeration8 *) (buf + 63) = ptpClock->timeSource;
 }
 
@@ -174,6 +192,8 @@
 void 
 msgUnpackAnnounce(Octet * buf, MsgAnnounce * announce)
 {
+	UInteger16 tmp;
+
 	announce->originTimestamp.secondsField.msb = 
 		flip16(*(UInteger16 *) (buf + 34));
 	announce->originTimestamp.secondsField.lsb = 
@@ -191,7 +211,10 @@
 	announce->grandmasterPriority2 = *(UInteger8 *) (buf + 52);
 	memcpy(announce->grandmasterIdentity, (buf + 53), 
 	       CLOCK_IDENTITY_LENGTH);
-	announce->stepsRemoved = flip16(*(UInteger16 *) (buf + 61));
+	memcpy(&tmp, (buf+61), sizeof(UInteger16));
+	announce->stepsRemoved = flip16(tmp);
+	/*announce->stepsRemoved = flip16(*(UInteger16 *) (buf + 61));
+	 */
 	announce->timeSource = *(Enumeration8 *) (buf + 63);
 	
 #ifdef PTPD_DBG
@@ -203,12 +226,9 @@
 void 
 msgPackFollowUp(Octet * buf, Timestamp * preciseOriginTimestamp, PtpClock * ptpClock)
 {
-	msgPackHeader(buf, ptpClock);
+	msgPackHeader(buf, ptpClock, FOLLOW_UP);
 	
 	/* changes in header */
-	*(char *)(buf + 0) = *(char *)(buf + 0) & 0xF0;
-	/* RAZ messageType */
-	*(char *)(buf + 0) = *(char *)(buf + 0) | 0x08;
 	/* Table 19 */
 	*(UInteger16 *) (buf + 2) = flip16(FOLLOW_UP_LENGTH);
 	*(UInteger16 *) (buf + 30) = flip16(ptpClock->sentSyncSequenceId - 1);
@@ -248,13 +268,10 @@
 void 
 msgPackPDelayReq(Octet * buf, Timestamp * originTimestamp, PtpClock * ptpClock)
 {
-	msgPackHeader(buf, ptpClock);
+	msgPackHeader(buf, ptpClock, PDELAY_REQ);
 
 	
 	/* changes in header */
-	*(char *)(buf + 0) = *(char *)(buf + 0) & 0xF0;
-	/* RAZ messageType */
-	*(char *)(buf + 0) = *(char *)(buf + 0) | 0x02;
 	/* Table 19 */
 	*(UInteger16 *) (buf + 2) = flip16(PDELAY_REQ_LENGTH);
 	*(UInteger16 *) (buf + 30) = flip16(ptpClock->sentPDelayReqSequenceId);
@@ -277,12 +294,9 @@
 void 
 msgPackDelayReq(Octet * buf, Timestamp * originTimestamp, PtpClock * ptpClock)
 {
-	msgPackHeader(buf, ptpClock);
+	msgPackHeader(buf, ptpClock, DELAY_REQ);
 	
 	/* changes in header */
-	*(char *)(buf + 0) = *(char *)(buf + 0) & 0xF0;
-	/* RAZ messageType */
-	*(char *)(buf + 0) = *(char *)(buf + 0) | 0x01;
 	/* Table 19 */
 	*(UInteger16 *) (buf + 2) = flip16(DELAY_REQ_LENGTH);
 
@@ -308,21 +322,12 @@
 void 
 msgPackDelayResp(Octet * buf, MsgHeader * header, Timestamp * receiveTimestamp, PtpClock * ptpClock)
 {
-	msgPackHeader(buf, ptpClock);
+	msgPackHeader(buf, ptpClock, DELAY_RESP);
 	
 	/* changes in header */
-	*(char *)(buf + 0) = *(char *)(buf + 0) & 0xF0;
-	/* RAZ messageType */
-	*(char *)(buf + 0) = *(char *)(buf + 0) | 0x09;
 	/* Table 19 */
 	*(UInteger16 *) (buf + 2) = flip16(DELAY_RESP_LENGTH);
 	*(UInteger8 *) (buf + 4) = header->domainNumber;
-
-#ifdef PTP_EXPERIMENTAL
-	if(rtOpts.do_hybrid_mode)    
-		*(char *)(buf + 6) |= PTP_UNICAST;
-#endif
-
 	memset((buf + 8), 0, 8);
 
 	/* Copy correctionField of PdelayReqMessage */
@@ -355,12 +360,9 @@
 void 
 msgPackPDelayResp(Octet * buf, MsgHeader * header, Timestamp * requestReceiptTimestamp, PtpClock * ptpClock)
 {
-	msgPackHeader(buf, ptpClock);
+	msgPackHeader(buf, ptpClock, PDELAY_RESP);
 	
 	/* changes in header */
-	*(char *)(buf + 0) = *(char *)(buf + 0) & 0xF0;
-	/* RAZ messageType */
-	*(char *)(buf + 0) = *(char *)(buf + 0) | 0x03;
 	/* Table 19 */
 	*(UInteger16 *) (buf + 2) = flip16(PDELAY_RESP_LENGTH);
 	*(UInteger8 *) (buf + 4) = header->domainNumber;
@@ -465,12 +467,9 @@
 void 
 msgPackPDelayRespFollowUp(Octet * buf, MsgHeader * header, Timestamp * responseOriginTimestamp, PtpClock * ptpClock)
 {
-	msgPackHeader(buf, ptpClock);
+	msgPackHeader(buf, ptpClock, PDELAY_RESP_FOLLOW_UP);
 	
 	/* changes in header */
-	*(char *)(buf + 0) = *(char *)(buf + 0) & 0xF0;
-	/* RAZ messageType */
-	*(char *)(buf + 0) = *(char *)(buf + 0) | 0x0A;
 	/* Table 19 */
 	*(UInteger16 *) (buf + 2) = flip16(PDELAY_RESP_FOLLOW_UP_LENGTH);
 	*(UInteger16 *) (buf + 30) = flip16(ptpClock->PdelayReqHeader.sequenceId);
